//
//  PhotoGroupViewController.swift
//  PhotoAlbumDemo01
//
//  Created by 张延深 on 2016/6/20.
//  Copyright © 2016年 宜信. All rights reserved.
//  设备中所有的group

import UIKit
import AssetsLibrary

class CEPhotoGroupViewController: UITableViewController {
    
    var assetsLibrary: ALAssetsLibrary = ALAssetsLibrary()
    var assetsGroup: NSMutableArray = NSMutableArray()
    
    // MARK: - Lifecycle
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.tableView.tableFooterView = UIView()
        
        assetsLibrary.enumerateGroupsWithTypes(ALAssetsGroupAll, usingBlock: { (group: ALAssetsGroup!, stop) in
            
            if group != nil {
                self.assetsGroup.addObject(group)
            }
            self.tableView.reloadData()
            
            }) { (error) in
               print(error)
        }
        
    }
    
    // MARK: - UITableViewDataSource
    
    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return assetsGroup.count
    }
    
    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCellWithIdentifier("cell", forIndexPath: indexPath)
        let group: ALAssetsGroup = assetsGroup[indexPath.row] as! ALAssetsGroup
        cell.imageView?.image = UIImage(CGImage: group.posterImage().takeUnretainedValue())
        cell.textLabel?.text = "\(group.valueForProperty(ALAssetsGroupPropertyName))（\(group.numberOfAssets())）"
        
        return cell
    }
    
    // MARK: - UITableViewDelegate
    
    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        
        tableView.deselectRowAtIndexPath(indexPath, animated: true)
        let vc = self.storyboard?.instantiateViewControllerWithIdentifier("CEPhotoViewController") as! CEPhotoViewController
        vc.group = assetsGroup[indexPath.row] as! ALAssetsGroup
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    // MARK: - deinit
    
    deinit {
        debugPrint("CEPhotoGroupViewController释放了！")
    }

}
